# Google Photo Plugin

## About
This plugin is designed on the top of Google API with OAuth 2.0 flow.

## Data to be imported
- Person:
    - displayName
    - firstName
    - lastName
    - email
- Account:
    - displayName
    - email
- Account - owner -> Person
- Photo:
    - name = fullname
    - caption = "Profile picture"
    - exifData
- Account - profilePicture -> Photo
- Service:
    - name = "google"
- Account - service -> Service
- Photo
    - width
    - height
    - format
    - filename
    - creationTime
- Service - photo -> Photo
- Video
    - fps
    - width
    - height
    - format
    - filename
    - creationTime
- Service - video -> Video
- Camera:
    - producer
    - model
- Photo - camera -> Camera
- Video - camera -> Camera

# How to run

## Step 1 : Create a google cloud project

Turn to this website `https://console.cloud.google.com/` , and following the instructure

## Step 2 : Enable API

1. Navigate this page to API & Service > Libraries.
2. Search `Google Drive API` , `Google Photo Library API`, `Google Gmail API`
3. Enable all of them 

## Step 3 : Create and load credentials

After create application, navigate this page to API & Service > Credentials. 
1. Click CREATE CREDENTIALS.
2. Select OAuth Client ID
3. Choose Desktop App at Application type selection
4. Load credentials to environment: 

```
    export GOOGLE_CLIENT_ID="..."
    export GOOGLE_CLIENT_SECRET="..."
    export PROJECT_ID="..."
```

## Step 4 : Create virtual environment

Please open terminal, cd path/to/this/repo , please type
```
    python3 -m venv env
```
## Step 5 : Activate Virtual environment
On the current terminal, please type 
```
    source env/bin/active
```

## Step 6 : Install all rependencies
On the current terminal, please type 
```
    pip3 install -r requirements.txt
```

## Step 7 : Start Memri server locally at pod repository
```
    ./examples/run_development.sh
```

## Step 8 : Now, you can start the plugin
```
    run_plugin --metadata metadata.json
``` 
The brower will be open automatically , please select and accept permissions. Your photos and videos will be imported to Memri Pod.

# TODOs
- Extract video exifData
- Extract location if exists